@rem # perform IEEE 1180 test series
@rem # Typical usage:
@rem #    doieee  progname  >outfile
@rem # where progname is ieeetest or a variant

@echo ------------------------------------------------------------------
@echo Test #1 : -256 255 1 10000
ieee1180 -256 255 1 1000 > output1.txt
@echo ------------------------------------------------------------------

@echo Test #2 : -5 5 1 10000
ieee1180 -5 5     1 1000 > output2.txt
@echo ------------------------------------------------------------------

@echo Test #3 : -300 300 1 10000
ieee1180 -300 300 1 1000 > output3.txt
@echo ------------------------------------------------------------------

@echo Test #4 : -256 255 -1 10000
ieee1180 -256 255 -1 1000 > output4.txt
@echo ------------------------------------------------------------------

@echo Test #5 : -5 5 -1 10000
ieee1180 -5 5     -1 1000 > output5.txt
@echo ------------------------------------------------------------------

@echo Test #6 : -300 300 -1 10000
ieee1180 -300 300 -1 1000 > output6.txt
@echo ------------------------------------------------------------------

@del output.txt
@copy output1.txt+output2.txt+output3.txt+output4.txt+output5.txt+output6.txt output.txt
@echo "Concatenated results saved to OUTPUT.TXT"
