#line 1 "c:\\work\\proj\\fdct1180\\fdct3dn.c"















































































































#line 1 "c:\\program files\\msdev\\vc98\\include\\math.h"















#pragma once
#line 18 "c:\\program files\\msdev\\vc98\\include\\math.h"






#line 25 "c:\\program files\\msdev\\vc98\\include\\math.h"







#pragma pack(push,8)
#line 34 "c:\\program files\\msdev\\vc98\\include\\math.h"














#line 49 "c:\\program files\\msdev\\vc98\\include\\math.h"
#line 50 "c:\\program files\\msdev\\vc98\\include\\math.h"






#line 57 "c:\\program files\\msdev\\vc98\\include\\math.h"








#line 66 "c:\\program files\\msdev\\vc98\\include\\math.h"
#line 67 "c:\\program files\\msdev\\vc98\\include\\math.h"







struct _exception {
        int type;       
        char *name;     
        double arg1;    
        double arg2;    
        double retval;  
        } ;


#line 84 "c:\\program files\\msdev\\vc98\\include\\math.h"







struct _complex {
        double x,y; 
        } ;




#line 99 "c:\\program files\\msdev\\vc98\\include\\math.h"


#line 102 "c:\\program files\\msdev\\vc98\\include\\math.h"
#line 103 "c:\\program files\\msdev\\vc98\\include\\math.h"





















 extern double _HUGE;
#line 126 "c:\\program files\\msdev\\vc98\\include\\math.h"



























#line 154 "c:\\program files\\msdev\\vc98\\include\\math.h"
        int     __cdecl abs(int);
        double  __cdecl acos(double);
        double  __cdecl asin(double);
        double  __cdecl atan(double);
        double  __cdecl atan2(double, double);
        double  __cdecl cos(double);
        double  __cdecl cosh(double);
        double  __cdecl exp(double);
        double  __cdecl fabs(double);
        double  __cdecl fmod(double, double);
        long    __cdecl labs(long);
        double  __cdecl log(double);
        double  __cdecl log10(double);
        double  __cdecl pow(double, double);
        double  __cdecl sin(double);
        double  __cdecl sinh(double);
        double  __cdecl tan(double);
        double  __cdecl tanh(double);
        double  __cdecl sqrt(double);
#line 174 "c:\\program files\\msdev\\vc98\\include\\math.h"
 double  __cdecl atof(const char *);
 double  __cdecl _cabs(struct _complex);



#line 180 "c:\\program files\\msdev\\vc98\\include\\math.h"
 double  __cdecl ceil(double);
 double  __cdecl floor(double);
#line 183 "c:\\program files\\msdev\\vc98\\include\\math.h"
 double  __cdecl frexp(double, int *);
 double  __cdecl _hypot(double, double);
 double  __cdecl _j0(double);
 double  __cdecl _j1(double);
 double  __cdecl _jn(int, double);
 double  __cdecl ldexp(double, int);
        int     __cdecl _matherr(struct _exception *);
 double  __cdecl modf(double, double *);

 double  __cdecl _y0(double);
 double  __cdecl _y1(double);
 double  __cdecl _yn(int, double);








































#line 236 "c:\\program files\\msdev\\vc98\\include\\math.h"







































#line 276 "c:\\program files\\msdev\\vc98\\include\\math.h"

































































































































#line 406 "c:\\program files\\msdev\\vc98\\include\\math.h"
#line 407 "c:\\program files\\msdev\\vc98\\include\\math.h"
#line 408 "c:\\program files\\msdev\\vc98\\include\\math.h"














#line 423 "c:\\program files\\msdev\\vc98\\include\\math.h"



 extern double HUGE;

 double  __cdecl cabs(struct _complex);
 double  __cdecl hypot(double, double);
 double  __cdecl j0(double);
 double  __cdecl j1(double);
 double  __cdecl jn(int, double);
        int     __cdecl _matherr(struct _exception *);
 double  __cdecl y0(double);
 double  __cdecl y1(double);
 double  __cdecl yn(int, double);

#line 439 "c:\\program files\\msdev\\vc98\\include\\math.h"

#line 441 "c:\\program files\\msdev\\vc98\\include\\math.h"






































































































































































































#pragma pack(pop)
#line 641 "c:\\program files\\msdev\\vc98\\include\\math.h"

#line 643 "c:\\program files\\msdev\\vc98\\include\\math.h"
#line 113 "c:\\work\\proj\\fdct1180\\fdct3dn.c"
#line 1 "c:\\work\\proj\\fdct1180\\amd3dx.h"




































































































































































































































































































































































































































































































































































































































































#line 646 "c:\\work\\proj\\fdct1180\\amd3dx.h"



#pragma warning(disable:4799)














































































































































































































































































































































































































































































































#line 1145 "c:\\work\\proj\\fdct1180\\amd3dx.h"


































































































#line 1244 "c:\\work\\proj\\fdct1180\\amd3dx.h"
#line 114 "c:\\work\\proj\\fdct1180\\fdct3dn.c"

static float aanscales[64]; 

























void init_fdct_3dnow()
{
  int i, j;
  static const double aansf[8] = {
    1.0, 
    1.38703984532214746182161919156644,
    1.30656296487637652785664317342719,
    1.17587560241935871697446710461126,
    1.0,  
    0.785694958387102181277897367657217,
    0.541196100146196984399723205366389,
    0.275899379282943012335957563669373
  };

  for (i = 0; i < 8; i++)
    for (j = 0; j < 8; j++)
      aanscales[(i<<3)+j] = (double)(32768.0) / (aansf[i]*aansf[j]*8.0);

}












void fdct_3dnow(short *block)
{
  static float data[64]; 
  
  static __int64  tmp7tmp6, tmp4tmp5;


  static const __int64 mmMask00001000 = 0x80000000; 
  static const __int64 mmMaskRnd = 0x0000400000004000; 

  
  static const float CONSTANTS[] = { 
      - 0.707106781186547524400844362104849, 0.707106781186547524400844362104849,     
        1.30656296487637652785664317342719, 0.541196100146196984399723205366389, 
        0.707106781186547524400844362104849, 0.382683432365089771728459984030399         
  };

























  static float  *dataptr; 
  static float *dataptr2;


















  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  


  
  

  




  
 

  dataptr = data;  
  dataptr2 = data;




     __asm {
     
     
     
     

     mov eax, dword ptr [block]; 
      pxor mm7, mm7;              

     mov edx, dword ptr [dataptr];
      mov edi, 0x08;               

     lea ebx, dword ptr [CONSTANTS];

tdn_dct_row1: 

     movq mm5, qword ptr [eax];   
      pxor mm0, mm0;              

     movq mm6, qword ptr [eax+8]; 
      pxor mm2, mm2;              

     movq mm1, mm5;               
      punpckhwd mm0, mm5;        

     movq mm3, mm6;               
      psrlq mm5, 16;              
      
     punpckhwd mm2, mm6;         
      psrlq mm6, 16;              

     punpcklwd mm5, mm1;          
      pxor mm1, mm1;              

     psrad mm0, 16;
      punpcklwd mm1, mm5;         

     punpcklwd mm6, mm3;          
      pxor mm3, mm3;              

     psrad mm2, 16;
      punpcklwd mm3, mm6;        

     psrad mm3, 16;

     add eax, 16;                
     psrad mm1, 16;
    





















    movq mm5, mm0; 
     movq mm4, mm1;  

























     psubd mm4, mm2; 
      psubd mm5, mm3; 

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc4 & 0x3f) << 3) | 0xc4 _asm _emit 0x0d };    
      paddd mm0, mm3;  

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc5 & 0x3f) << 3) | 0xc5 _asm _emit 0x0d };   
      paddd mm1, mm2;  

     movq [tmp7tmp6], mm4;
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc1 _asm _emit 0x0d };    

     movq [tmp4tmp5], mm5;
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc0 _asm _emit 0x0d };   









    












    movq mm6, mm1;       
     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc0 _asm _emit 0x9a };      

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc6 & 0x3f) << 3) | 0xc0 _asm _emit 0x9e };      











    movq mm7, mm1;
     punpckhdq mm7, mm7;      

    movq mm2, mm6;     


     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc1 _asm _emit 0xae }; 




    pxor mm2, [mmMask00001000]; 
     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc6 & 0x3f) << 3) | 0xc2 _asm _emit 0xae }; 
    







      movd dword ptr [ edx + 32*0 ], mm6; 
     psrlq mm6, 32;    



    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc1 & 0x3f) << 3) | 0x03 + 0 | 0x40) _asm _emit 0 _asm _emit 0xb4 }; 


    movd dword ptr [ edx + 32*4 ], mm6; 


    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc7 & 0x3f) << 3) | 0xc1 _asm _emit 0x9e };  






    movd dword ptr [edx + 32*6], mm7; 
     psrlq mm7, 32;    


    movd dword ptr [edx + 32*2], mm7; 











    movq mm0, [tmp7tmp6];  

    movq mm1, [tmp4tmp5];
     movq mm2, mm0;     

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc1 _asm _emit 0xae }; 
    
    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc2 _asm _emit 0x9e }; 



    movq mm3, mm0;   


    punpckldq mm1,mm1; 
     movq mm2, mm0;   

    punpckhdq mm3, mm1; 



    











    pxor mm2, [mmMask00001000]; 
     psllq mm1, 32;             






    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc0 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 8 _asm _emit 0xb4 }; 
     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc2 _asm _emit 0xae };  




    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc1 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 16 _asm _emit 0xb4 }; 




    movq mm7, mm1;        
     movq mm6, mm1;        

    punpckhdq mm7,mm7;    
     punpckldq mm6,mm6;    





    pxor mm6, [mmMask00001000];  

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc7 _asm _emit 0x9e };        


    movq mm5, [tmp7tmp6];    

    punpckhdq mm5,mm5;    








    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc5 & 0x3f) << 3) | 0xc6 _asm _emit 0x9a };   
     movq mm4, mm0;    









    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc4 & 0x3f) << 3) | 0xc5 _asm _emit 0x9e }; 

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc5 & 0x3f) << 3) | 0xc0 _asm _emit 0x9a };  


      movd [edx + 32*1], mm4; 
  
     psrlq mm4, 32;      


    movd [edx + 32*7], mm5; 
     psrlq mm5, 32;      


    movd [edx + 32*5], mm4; 
     sub edi, 0x01;          


    movd [edx + 32*3], mm5; 

     add edx, 4;            

    cmp edi, 0x00;          
     jg tdn_dct_row1;  
















































  





     
     
     
     
     
     
     
     
     
     
     

  
  




     
     

     mov eax, dword ptr [dataptr]; 
      pxor mm7, mm7;              

     mov edx, dword ptr [dataptr2];
      mov edi, 0x08;               

     lea ebx, dword ptr [CONSTANTS];
     
     
     

tdn_dct_col1: 













     movd mm1, dword ptr [eax+4*1];  
     
     punpckldq mm1, dword ptr [eax+4*0];  

     movd mm3, dword ptr [eax+4*5];  
      movq mm4, mm1;            

     punpckldq mm3, dword ptr [eax+4*4];  

     movq mm0, qword ptr [eax+4*2];  

     movq mm2, qword ptr [eax+4*6];  
      movq mm5, mm0;            



































     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc4 & 0x3f) << 3) | 0xc2 _asm _emit 0x9a }; 
      add eax, 4*8;       

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc5 & 0x3f) << 3) | 0xc3 _asm _emit 0x9a };

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc3 _asm _emit 0x9e };  
     movq [tmp7tmp6], mm4;

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc2 _asm _emit 0x9e }; 
     movq [tmp4tmp5], mm5;





    












    movq mm6, mm1;       
     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc0 _asm _emit 0x9a };      

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc6 & 0x3f) << 3) | 0xc0 _asm _emit 0x9e };      











    movq mm7, mm1;
     punpckhdq mm7, mm7;      

    movq mm2, mm6;     


     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc1 _asm _emit 0xae }; 




    pxor mm2, [mmMask00001000]; 
     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc6 & 0x3f) << 3) | 0xc2 _asm _emit 0xae }; 
    






    movd dword ptr [ edx + 4*0 ], mm6; 

     psrlq mm6, 32;    



    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc1 & 0x3f) << 3) | 0x03 + 0 | 0x40) _asm _emit 0 _asm _emit 0xb4 }; 

    movd dword ptr [ edx + 4*4 ], mm6; 



    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc7 & 0x3f) << 3) | 0xc1 _asm _emit 0x9e };  





    movd dword ptr [edx + 4*6], mm7; 

     psrlq mm7, 32;    

    movd dword ptr [edx + 4*2], mm7; 












    movq mm0, [tmp7tmp6];  

    movq mm1, [tmp4tmp5];
     movq mm2, mm0;     

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc1 _asm _emit 0xae }; 
    
    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc2 _asm _emit 0x9e }; 



    movq mm3, mm0;   


    punpckldq mm1,mm1; 
     movq mm2, mm0;   

    punpckhdq mm3, mm1; 



    











    pxor mm2, [mmMask00001000]; 
     psllq mm1, 32;             






    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc0 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 8 _asm _emit 0xb4 }; 
     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc2 _asm _emit 0xae };  




    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc1 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 16 _asm _emit 0xb4 }; 




    movq mm7, mm1;        
     movq mm6, mm1;        

    punpckhdq mm7,mm7;    
     punpckldq mm6,mm6;    





    pxor mm6, [mmMask00001000];  

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc7 _asm _emit 0x9e };        


    movq mm5, [tmp7tmp6];    

    punpckhdq mm5,mm5;    








    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc5 & 0x3f) << 3) | 0xc6 _asm _emit 0x9a };   
     movq mm4, mm0;    









    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc4 & 0x3f) << 3) | 0xc5 _asm _emit 0x9e }; 

    { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc5 & 0x3f) << 3) | 0xc0 _asm _emit 0x9a };  

      movd [edx + 4*1], mm4; 

  
     psrlq mm4, 32;      

    movd [edx + 4*7], mm5; 

     psrlq mm5, 32;      

    movd [edx + 4*5], mm4; 

     sub edi, 0x01;          

    movd [edx + 4*3], mm5; 

     add edx, 32;            


    cmp edi, 0x00;          
     jg tdn_dct_col1;  












  

  










    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

    

    
    
    
    
    

















     mov eax, dword ptr [dataptr2];
      mov edi, 0x04;               

     lea ebx, dword ptr [aanscales];
      mov ecx, eax;                 

     movq mm7, [mmMaskRnd]; 
      add ecx, 128;                

     mov edx, dword ptr [block];   
      sub ebx, 64;

tdn_dct_postproc: 
     
     

     movq mm0, qword ptr [eax+32*0];  
      add ebx, 64;

     movq mm2, qword ptr [eax+32*1];  
      movq mm1, mm0; 
  
     movq mm3, qword ptr [eax+32*2]; 
      punpckldq mm0,mm2; 

     movq mm4, qword ptr [eax+32*3]; 
      punpckhdq mm1, mm2; 

     movq mm2, mm3;  
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc0 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 0 _asm _emit 0xb4 };  

     punpckldq mm2, mm4; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc1 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 0+32 _asm _emit 0xb4 }; 

     punpckhdq mm3, mm4; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc2 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 8 _asm _emit 0xb4 }; 

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc3 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 8+32 _asm _emit 0xb4 }; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc0 _asm _emit 0x1d }; 

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc1 _asm _emit 0x1d }; 
      add eax, 8;

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc2 & 0x3f) << 3) | 0xc2 _asm _emit 0x1d }; 
      paddd  mm0, mm7; 

     paddd  mm1, mm7; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc3 & 0x3f) << 3) | 0xc3 _asm _emit 0x1d }; 

     paddd  mm2, mm7; 
      psrad mm0, 15; 

     paddd  mm3, mm7; 
      psrad mm2, 15; 

     packssdw mm0, mm2;     
      psrad mm1, 15; 

     movq qword ptr [edx], mm0; 
      psrad mm3, 15; 

     packssdw mm1, mm3;    








      movq mm0, qword ptr [ecx+32*0];  

     movq qword ptr [edx+16], mm1; 

     movq mm2, qword ptr [ecx+32*1];  
      movq mm1, mm0; 
  
     movq mm3, qword ptr [ecx+32*2]; 
      punpckldq mm0,mm2; 

     movq mm4, qword ptr [ecx+32*3]; 
      punpckhdq mm1, mm2; 

     movq mm2, mm3;  
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc0 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 16 _asm _emit 0xb4 };  

     punpckldq mm2, mm4; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc1 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 16+32 _asm _emit 0xb4 }; 

     punpckhdq mm3, mm4; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc2 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 16+8 _asm _emit 0xb4 }; 

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit (((0xc3 & 0x3f) << 3) | 0x03 | 0x40) _asm _emit 16+8+32 _asm _emit 0xb4 }; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc0 & 0x3f) << 3) | 0xc0 _asm _emit 0x1d }; 

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc1 & 0x3f) << 3) | 0xc1 _asm _emit 0x1d }; 
      add ecx, 8;

     { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc2 & 0x3f) << 3) | 0xc2 _asm _emit 0x1d }; 
      paddd  mm0, mm7; 

     paddd  mm1, mm7; 
      { _asm _emit 0x0f _asm _emit 0x0f _asm _emit ((0xc3 & 0x3f) << 3) | 0xc3 _asm _emit 0x1d }; 

     paddd  mm2, mm7; 
      psrad mm0, 15; 

     paddd  mm3, mm7; 
      psrad mm2, 15; 

     packssdw mm0, mm2;     
      psrad mm1, 15; 

     movq qword ptr [edx+8], mm0; 
      psrad mm3, 15; 

     packssdw mm1, mm3;    
      sub edi, 1;      

     movq qword ptr [edx+8+16], mm1; 
      add edx, 32;

     cmp edi, 0x00;   

     jg tdn_dct_postproc;  
     { _asm _emit 0x0f _asm _emit 0x0e };
   };

}
